<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8" />
    <title>Sync for Firefox</title>
    <meta name="viewport" content="width=device-width, initial-scale=1" />

    <style>
      * {
        font-family: system-ui, -apple-system, BlinkMacSystemFont, "Segoe UI",
          Roboto, Oxygen, Ubuntu, Cantarell, "Open Sans", "Helvetica Neue",
          sans-serif;
      }

      #firefox-logo {
        height: 10vh;
      }

      html,
      body {
        margin: 0;
        padding: 0;
        color-scheme: light dark;
      }

      body {
        display: flex;
        flex-direction: column;
        align-items: center;
        justify-content: center;
        padding: 2rem;
        text-align: center;
        height: 100vh;
        width: 100vw;
        box-sizing: border-box;
      }

      h1 {
        margin-bottom: 0;
        font-size: 2.5rem;
      }

      #linkWrapper {
        margin: 1rem 0;
        font-size: larger;
      }

      #links {
        margin-top: 0.5rem;
        display: flex;
        flex-direction: row;
        align-items: center;
        justify-content: center;
        gap: 1rem;
      }

      #links a {
        display: inline;
      }

      #explanation {
        max-width: 70ch;
      }

      input {
        margin: 0.5rem;
        padding: 0.5rem;
        border-radius: 0.25rem;
        border: 1px solid #ccc;
      }

      label {
        display: block;
        margin-bottom: 0.25rem;
      }

      button {
        display: block;
        padding: 0.5rem 1rem;
        border-radius: 0.25rem;
        border: none;
        background-color: #0078d4;
        color: white;
        cursor: pointer;
        margin-left: auto;
        margin-right: auto;
      }
    </style>
  </head>
  <body>
    <svg
      version="1.1"
      viewBox="0 0 120.02492 119.78642"
      xmlns="http://www.w3.org/2000/svg"
      id="firefox-logo"
    >
      <radialGradient
        id="a"
        cx="116.07972"
        cy="17.98517"
        r="107.91191"
        gradientTransform="matrix(1.0009992 0 0 .99900184 -.97465723 .00014864992)"
        gradientUnits="userSpaceOnUse"
      >
        <stop stop-color="#fff36e" offset="0" />
        <stop stop-color="#fc4055" offset=".5" />
        <stop stop-color="#e31587" offset="1" />
      </radialGradient>
      <radialGradient
        id="b"
        cx="12.963897"
        cy="21.582234"
        r="83.931483"
        gradientTransform="matrix(1.0009992 0 0 .99900184 -.97465723 .00014864992)"
        gradientUnits="userSpaceOnUse"
      >
        <stop stop-color="#c60084" offset="0" />
        <stop stop-color="#fc4055" stop-opacity="0" offset="1" />
      </radialGradient>
      <radialGradient
        id="c"
        cx="132.86602"
        cy="9.5920206"
        r="159.46982"
        gradientTransform="matrix(1.0009992 0 0 .99900184 -.97465723 .00014864992)"
        gradientUnits="userSpaceOnUse"
      >
        <stop stop-color="#ffde67" stop-opacity=".6" offset="0" />
        <stop stop-color="#fc4055" stop-opacity="0" offset=".66" />
      </radialGradient>
      <radialGradient
        id="d"
        cx="53.730617"
        cy="61.149931"
        r="209.82871"
        gradientTransform="matrix(1.0009992 0 0 .99900184 -.97465723 .00014864992)"
        gradientUnits="userSpaceOnUse"
      >
        <stop stop-color="#810220" offset=".15" />
        <stop stop-color="#fc4055" stop-opacity="0" offset=".27" />
      </radialGradient>
      <radialGradient
        id="e"
        cx="64.521805"
        cy="65.946019"
        r="191.8434"
        gradientTransform="matrix(1.0009992 0 0 .99900184 -.97465723 .00014864992)"
        gradientUnits="userSpaceOnUse"
      >
        <stop stop-color="#810220" offset=".12" />
        <stop stop-color="#fc4055" stop-opacity="0" offset=".3" />
      </radialGradient>
      <radialGradient
        id="f"
        cx="105.81848"
        cy="12.603277"
        r="119.31783"
        gradientTransform="matrix(.99882403 0 0 1.0011774 -.97465723 .00014864992)"
        gradientUnits="userSpaceOnUse"
      >
        <stop stop-color="#ff9640" offset="0" />
        <stop stop-color="#fc4055" offset=".8" />
      </radialGradient>
      <radialGradient
        id="g"
        cx="106.89342"
        cy="20.127826"
        r="121.4677"
        gradientTransform="matrix(.99882403 0 0 1.0011774 -.97465723 .00014864992)"
        gradientUnits="userSpaceOnUse"
      >
        <stop stop-color="#ffde67" offset=".09" />
        <stop stop-color="#ff9640" stop-opacity="0" offset=".82" />
      </radialGradient>
      <radialGradient
        id="h"
        cx="76.79523"
        cy="53.450822"
        r="58.046512"
        gradientTransform="matrix(.99882403 0 0 1.0011774 -.97465723 .00014864992)"
        gradientUnits="userSpaceOnUse"
      >
        <stop stop-color="#fc4055" offset=".36" />
        <stop stop-color="#ff9640" stop-opacity="0" offset=".59" />
      </radialGradient>
      <radialGradient
        id="i"
        cx="66.045874"
        cy="56.675625"
        r="58.046512"
        gradientTransform="matrix(.99882403 0 0 1.0011774 -.97465723 .00014864992)"
        gradientUnits="userSpaceOnUse"
      >
        <stop stop-color="#fc4055" stop-opacity=".8" offset=".22" />
        <stop stop-color="#ff9640" stop-opacity="0" offset=".47" />
      </radialGradient>
      <radialGradient
        id="j"
        cx="120.80753"
        cy="3.7704161"
        r="142.61804"
        gradientTransform="matrix(.99028759 0 0 1.0098077 -.97465723 .00014864992)"
        gradientUnits="userSpaceOnUse"
      >
        <stop stop-color="#fff36e" offset=".05" />
        <stop stop-color="#ff9640" offset=".55" />
        <stop stop-color="#ff9640" offset=".7" />
      </radialGradient>
      <linearGradient
        id="k"
        x1="67.056017"
        x2="89.821755"
        y1="-2.35517"
        y2="62.016912"
        gradientTransform="matrix(1.04439 0 0 .95749676 -.97465723 .00014864992)"
        gradientUnits="userSpaceOnUse"
      >
        <stop stop-color="#b833e1" offset="0" />
        <stop stop-color="#9059ff" offset=".37" />
        <stop stop-color="#0090ed" offset="1" />
      </linearGradient>
      <linearGradient
        id="l"
        x1="94.531907"
        x2="52.92556"
        y1="40.036199"
        y2="-7.8503477"
        gradientTransform="matrix(1.04439 0 0 .95749676 -.97465723 .00014864992)"
        gradientUnits="userSpaceOnUse"
      >
        <stop stop-color="#592acb" stop-opacity=".5" offset="0" />
        <stop stop-color="#722291" stop-opacity="0" offset=".24" />
      </linearGradient>
      <linearGradient
        id="m"
        x1="85.827591"
        x2="24.695655"
        y1="23.978323"
        y2="125.86488"
        gradientTransform="matrix(1.0601962 0 0 .9432216 -.97465723 .00014864992)"
        gradientUnits="userSpaceOnUse"
      >
        <stop stop-color="#fff36e" stop-opacity=".8" offset="0" />
        <stop stop-color="#fff36e" stop-opacity=".7" offset=".09" />
        <stop stop-color="#fff36e" stop-opacity="0" offset=".75" />
      </linearGradient>
      <path
        d="m107.94134 23.551149a59.21 59.21 0 0 0-45.533997-23.53800035c-13.93-0.278-23.555 3.90799995-29 7.27399995 7.285-4.226 17.827-6.62199995 27.058-6.50499995 23.747 0.29999995 49.248997 16.47300035 53.035997 45.62100035 4.348 33.459-18.954997 61.385001-51.738997 61.469001-36.068 0.093-58.0000002-31.843001-52.2710002-60.528001 0.286-1.432 0.143-2.825 0.6210002-4.179 0.273-5.044 2.178-12.95 6.288-21.027-4.152 2.148-9.4410002 8.946-12.0520002 15.243a62.038 62.038 0 0 0-3.90000003 30.262c0.09 0.778 0.171 1.553 0.273 2.324a60.093 60.093 0 1 0 107.2199972-46.416z"
        fill="url(#a)"
      />
      <path
        d="m107.94134 23.551149a59.21 59.21 0 0 0-45.533997-23.53800035c-13.93-0.278-23.555 3.90799995-29 7.27399995 7.285-4.226 17.827-6.62199995 27.058-6.50499995 23.747 0.29999995 49.248997 16.47300035 53.035997 45.62100035 4.348 33.459-18.954997 61.385001-51.738997 61.469001-36.068 0.093-58.0000002-31.843001-52.2710002-60.528001 0.286-1.432 0.143-2.825 0.6210002-4.179 0.273-5.044 2.178-12.95 6.288-21.027-4.152 2.148-9.4410002 8.946-12.0520002 15.243a62.038 62.038 0 0 0-3.90000003 30.262c0.09 0.778 0.171 1.553 0.273 2.324a60.093 60.093 0 1 0 107.2199972-46.416z"
        fill="url(#b)"
        opacity=".67"
      />
      <path
        d="m107.94134 23.551149a59.21 59.21 0 0 0-45.533997-23.53800035c-13.93-0.278-23.555 3.90799995-29 7.27399995 7.285-4.226 17.827-6.62199995 27.058-6.50499995 23.747 0.29999995 49.248997 16.47300035 53.035997 45.62100035 4.348 33.459-18.954997 61.385001-51.738997 61.469001-36.068 0.093-58.0000002-31.843001-52.2710002-60.528001 0.286-1.432 0.143-2.825 0.6210002-4.179 0.273-5.044 2.178-12.95 6.288-21.027-4.152 2.148-9.4410002 8.946-12.0520002 15.243a62.038 62.038 0 0 0-3.90000003 30.262c0.09 0.778 0.171 1.553 0.273 2.324a60.093 60.093 0 1 0 107.2199972-46.416z"
        fill="url(#c)"
      />
      <path
        d="m107.94134 23.551149a59.21 59.21 0 0 0-45.533997-23.53800035c-13.93-0.278-23.555 3.90799995-29 7.27399995 7.285-4.226 17.827-6.62199995 27.058-6.50499995 23.747 0.29999995 49.248997 16.47300035 53.035997 45.62100035 4.348 33.459-18.954997 61.385001-51.738997 61.469001-36.068 0.093-58.0000002-31.843001-52.2710002-60.528001 0.286-1.432 0.143-2.825 0.6210002-4.179 0.273-5.044 2.178-12.95 6.288-21.027-4.152 2.148-9.4410002 8.946-12.0520002 15.243a62.038 62.038 0 0 0-3.90000003 30.262c0.09 0.778 0.171 1.553 0.273 2.324a60.093 60.093 0 1 0 107.2199972-46.416z"
        fill="url(#d)"
      />
      <path
        d="m107.94134 23.551149a59.21 59.21 0 0 0-45.533997-23.53800035c-13.93-0.278-23.555 3.90799995-29 7.27399995 7.285-4.226 17.827-6.62199995 27.058-6.50499995 23.747 0.29999995 49.248997 16.47300035 53.035997 45.62100035 4.348 33.459-18.954997 61.385001-51.738997 61.469001-36.068 0.093-58.0000002-31.843001-52.2710002-60.528001 0.286-1.432 0.143-2.825 0.6210002-4.179 0.273-5.044 2.178-12.95 6.288-21.027-4.152 2.148-9.4410002 8.946-12.0520002 15.243a62.038 62.038 0 0 0-3.90000003 30.262c0.09 0.778 0.171 1.553 0.273 2.324a60.093 60.093 0 1 0 107.2199972-46.416z"
        fill="url(#e)"
      />
      <path
        d="m114.96234 44.739149c-3.377-30.462-30.542997-44.15400035-54.496997-43.95700035-9.231 0.076-19.773 2.27899995-27.059 6.50499995a29.557 29.557 0 0 0-5.339 4.0540004c0.193-0.16 0.77-0.635 1.727-1.292l0.1-0.066 0.083-0.056a39.949 39.949 0 0 1 11.534-5.358 65.225 65.225 0 0 1 19.774-2.312 49.879 49.879 0 0 1 46.874997 47.9820004c0.551 19.809-15.662997 35.607-34.352997 36.522-13.593 0.665-26.4-5.912-32.655-19.071a32.5 32.5 0 0 1-2.945-9.5c-2.965-20.025 10.483-37.102 22.818-41.33-6.653-5.811-23.322-5.417-35.728 3.71-8.939 6.573-14.735 16.574-16.6550002 28.505a49.423 49.423 0 0 0 3.5100002 27 52.96 52.96 0 0 0 45.135 32.156001q2.232 0.169 4.475 0.169c39.692997 5e-3 56.916997-30.126001 53.199997-63.661001z"
        fill="url(#f)"
      />
      <path
        d="m114.96234 44.739149c-3.377-30.462-30.542997-44.15400035-54.496997-43.95700035-9.231 0.076-19.773 2.27899995-27.059 6.50499995a29.557 29.557 0 0 0-5.339 4.0540004c0.193-0.16 0.77-0.635 1.727-1.292l0.1-0.066 0.083-0.056a39.949 39.949 0 0 1 11.534-5.358 65.225 65.225 0 0 1 19.774-2.312 49.879 49.879 0 0 1 46.874997 47.9820004c0.551 19.809-15.662997 35.607-34.352997 36.522-13.593 0.665-26.4-5.912-32.655-19.071a32.5 32.5 0 0 1-2.945-9.5c-2.965-20.025 10.483-37.102 22.818-41.33-6.653-5.811-23.322-5.417-35.728 3.71-8.939 6.573-14.735 16.574-16.6550002 28.505a49.423 49.423 0 0 0 3.5100002 27 52.96 52.96 0 0 0 45.135 32.156001q2.232 0.169 4.475 0.169c39.692997 5e-3 56.916997-30.126001 53.199997-63.661001z"
        fill="url(#g)"
      />
      <path
        d="m114.96234 44.739149c-3.377-30.462-30.542997-44.15400035-54.496997-43.95700035-9.231 0.076-19.773 2.27899995-27.059 6.50499995a29.557 29.557 0 0 0-5.339 4.0540004c0.193-0.16 0.77-0.635 1.727-1.292l0.1-0.066 0.083-0.056a39.949 39.949 0 0 1 11.534-5.358 65.225 65.225 0 0 1 19.774-2.312 49.879 49.879 0 0 1 46.874997 47.9820004c0.551 19.809-15.662997 35.607-34.352997 36.522-13.593 0.665-26.4-5.912-32.655-19.071a32.5 32.5 0 0 1-2.945-9.5c-2.965-20.025 10.483-37.102 22.818-41.33-6.653-5.811-23.322-5.417-35.728 3.71-8.939 6.573-14.735 16.574-16.6550002 28.505a49.423 49.423 0 0 0 3.5100002 27 52.96 52.96 0 0 0 45.135 32.156001q2.232 0.169 4.475 0.169c39.692997 5e-3 56.916997-30.126001 53.199997-63.661001z"
        fill="url(#h)"
        opacity=".53"
      />
      <path
        d="m114.96234 44.739149c-3.377-30.462-30.542997-44.15400035-54.496997-43.95700035-9.231 0.076-19.773 2.27899995-27.059 6.50499995a29.557 29.557 0 0 0-5.339 4.0540004c0.193-0.16 0.77-0.635 1.727-1.292l0.1-0.066 0.083-0.056a39.949 39.949 0 0 1 11.534-5.358 65.225 65.225 0 0 1 19.774-2.312 49.879 49.879 0 0 1 46.874997 47.9820004c0.551 19.809-15.662997 35.607-34.352997 36.522-13.593 0.665-26.4-5.912-32.655-19.071a32.5 32.5 0 0 1-2.945-9.5c-2.965-20.025 10.483-37.102 22.818-41.33-6.653-5.811-23.322-5.417-35.728 3.71-8.939 6.573-14.735 16.574-16.6550002 28.505a49.423 49.423 0 0 0 3.5100002 27 52.96 52.96 0 0 0 45.135 32.156001q2.232 0.169 4.475 0.169c39.692997 5e-3 56.916997-30.126001 53.199997-63.661001z"
        fill="url(#i)"
        opacity=".53"
      />
      <path
        d="m73.807343 86.761149c25.653-1.561 36.629997-22.795 37.317997-37.868 1.074-23.539-12.892997-48.92300035-49.839997-46.6360004a65.225 65.225 0 0 0-19.774 2.312 43.317 43.317 0 0 0-11.539 5.358l-0.083 0.056-0.1 0.066q-0.861 0.6-1.685 1.263c1.028-0.7 13.769-8.2270004 31.471-5.9000004 21.207 2.783 40.599997 19.2860004 40.599997 41.0600004 0 16.753-12.946997 29.543-28.105997 28.63-22.523-1.357-28.2-24.452-16.484-34.431-3.159-0.681-9.1 0.652-13.23 6.832-3.709 5.546-3.5 14.115-1.211 20.191 6.266 13.155 19.081 19.893 32.663 19.067z"
        fill="url(#j)"
      />
      <path
        d="m108.04834 28.089149a33.676 33.676 0 0 0-7.323-12.216 45.32 45.32 0 0 0-13.641997-9.7400004 60.746 60.746 0 0 0-13.409-4.753 59.728 59.728 0 0 0-24.849-0.145c-8.524 1.8-16.02 5.487-20.761 10.1000004a48.112 48.112 0 0 1 12.046-4.8000004 50.346 50.346 0 0 1 46.76 12.1490004 40.5 40.5 0 0 1 6.493 7.954c7.342997 11.938 6.647997 26.946 0.923 35.8-4.252 6.569-13.361 12.738-21.861 12.671 13.04 0.684 25.2-4.809 32.569997-16.309 5.983-9.336 6.187-21.217 3.053-30.711z"
        fill="url(#k)"
      />
      <path
        d="m108.04834 28.089149a33.676 33.676 0 0 0-7.323-12.216 45.32 45.32 0 0 0-13.641997-9.7400004 60.746 60.746 0 0 0-13.409-4.753 59.728 59.728 0 0 0-24.849-0.145c-8.524 1.8-16.02 5.487-20.761 10.1000004a48.112 48.112 0 0 1 12.046-4.8000004 50.346 50.346 0 0 1 46.76 12.1490004 40.5 40.5 0 0 1 6.493 7.954c7.342997 11.938 6.647997 26.946 0.923 35.8-4.252 6.569-13.361 12.738-21.861 12.671 13.04 0.684 25.2-4.809 32.569997-16.309 5.983-9.336 6.187-21.217 3.053-30.711z"
        fill="url(#l)"
      />
      <path
        d="m107.94134 23.551149a59.761 59.761 0 0 0-5.223-5.973 46.989 46.989 0 0 0-4.764997-4.389 36.754 36.754 0 0 1 2.772997 2.684 33.681 33.681 0 0 1 7.322 12.215c3.134 9.495 2.93 21.376-3.053 30.708-7.128997 11.12-18.735997 16.61-31.281997 16.342-0.543 0-1.087-7e-3 -1.636-0.04-22.523-1.357-28.2-24.452-16.484-34.431-3.159-0.681-9.1 0.652-13.23 6.832-3.709 5.546-3.5 14.115-1.211 20.191a32.5 32.5 0 0 1-2.945-9.5c-2.965-20.024 10.483-37.102 22.818-41.33-6.654-5.811-23.323-5.417-35.729 3.71a41.772 41.772 0 0 0-15.131 21.9 57.775 57.775 0 0 1 6.238-20.328c-4.152 2.148-9.4410002 8.946-12.0520002 15.243a62.041 62.041 0 0 0-3.90000003 30.263c0.09 0.777 0.171 1.552 0.273 2.323a60.093 60.093 0 1 0 107.2169972-46.42z"
        fill="url(#m)"
      />
    </svg>

    <h1>Sync server for Firefox</h1>
    <p id="explanation">
      Before using your server, you need to initialize it. Please note that the
      settings below can not be changed, so we recommend leaving the user limit
      at a high number. Also, changing the domain via the Nirvati UI will cause
      sync issues.
    </p>
    <form id="initApp">
      <label for="domain">Domain</label>
      <input name="domain" type="text" id="domain" />
      <label for="user_limit">User limit</label>
      <input name="user_limit" type="number" value="100" />
      <button type="submit">Initialize</button>
    </form>
    <script>
      document.getElementById("domain").value =
        "https://" + window.location.hostname;
      function initApp(e) {
        e.preventDefault();
        const domain = document.querySelector('input[name="domain"]').value;
        const userLimit = Number(document.querySelector(
          'input[name="user_limit"]'
        ).value);
        if (userLimit < 1) {
          alert("User limit must be at least 1");
          return;
        }
        if (!domain.startsWith("https://")) {
          alert("Domain must start with https://");
          return;
        }
        fetch("/init", {
          method: "POST",
          headers: {
            "Content-Type": "application/json",
          },
          body: JSON.stringify({ domain, userLimit }),
        })
          .then((res) => {
            if (res.ok) {
              window.location.href = "/";
            } else {
              alert("Failed to initialize server");
            }
          })
          .catch((err) => {
            alert("Failed to initialize server");
          });
      }
      document.getElementById("initApp").addEventListener("submit", initApp);
    </script>
    <p>
      <small
        >This integration, while being based on
        <a href="https://github.com/mozilla-services/syncstorage-rs"
          >Mozilla's open source Sync Server</a
        >, is not an official Mozilla application.<br />If you experience sync
        issues, please contact the Nirvati team and do not report it as a bug to
        Mozilla.
        <br />
        <br />
        Firefox is a trademark of the Mozilla Foundation in the US and other
        countries.
      </small>
    </p>
  </body>
</html>
